package com.alienfactory.javamappy.loader;

import com.alienfactory.javamappy.Map;
import com.alienfactory.javamappy.util.Logger;



// -----------------------------------------------------------------------------
/**
 * Chunk ATHR :: Up to 4 ASCII strings of author information. <br>
 *
 * @author Steve Eynon
 **/
// -----------------------------------------------------------------------------
public class ChunkLoaderATHR extends ChunkLoader {
	private final Logger log = Logger.createLogger(super.getClass());



	// -------------------------------------------------------------------------
	// Public Methods
	// -------------------------------------------------------------------------

	// JavaDoc inherited from ChunkLoader
	public void loadChunk(Map map) throws ChunkLoadException {
		String		desc[];
		int			strIndex;

		// read in the 4 lines of text
		desc = new String[4];
		for (strIndex = 0; strIndex < desc.length; strIndex++)
			desc[strIndex] = super.readString();

		log.info("Author      :: " + desc[0]);
		log.info("Description :: " + desc[1]);
		log.info("            :: " + desc[2]);
		log.info("            :: " + desc[3]);

        // save out map description
		map.setDescription(desc);
	}

}
