package com.alienfactory.javamappy.loader;

import com.alienfactory.javamappy.Map;
import com.alienfactory.javamappy.util.Logger;



// -----------------------------------------------------------------------------
/**
 * Chunk CMAP :: Colour palette for 8bit maps. <br>
 *
 * @author Steve Eynon
 **/
// -----------------------------------------------------------------------------
public class ChunkLoaderCMAP extends ChunkLoader {
	private final Logger log = Logger.createLogger(super.getClass());



	// -------------------------------------------------------------------------
	// Public Methods
	// -------------------------------------------------------------------------

	// JavaDoc inherited from ChunkLoader
	public void loadChunk(Map map) throws ChunkLoadException {

		int 			noOfEntries	= super.getBytesRemaining() / 3;
		int[]			colours 	= new int[noOfEntries];
		StringBuffer	hex 		= new StringBuffer();

		log.info("Reading " + noOfEntries + " CMAP entries.");
		for (int i=0; i<noOfEntries; i++) {

			colours[i] = (0xFF << 24) | (super.readUByte() << 16) | (super.readUByte() << 8) | super.readUByte();

			hex.append("0x");
			hex.append(Integer.toHexString(colours[i]).toUpperCase());
			hex.append(" ");
			if (((i+1)%8) == 0) {
				log.debug(hex.toString());
				hex = new StringBuffer();
			}
		}
		map.setColours(colours);
		if (!hex.toString().equals(""))	log.debug(hex.toString());
	}

}
