package com.alienfactory.javamappy.loader;

import java.util.ArrayList;

import com.alienfactory.javamappy.Map;



//------------------------------------------------------------------------------
/**
 * Chunk OBFN :: Contains OBJ Filenames for OBJSTR. <br>
 * Load the Object Filenames from the MapWin32 Pro editor. <br>
 *
 * @author Kris Arndt
 **/
// ------------------------------------------------------------------------------
public class ChunkLoaderOBFN extends ChunkLoader {

	// --------------------------------------------------------------------------
	// Public Methods
	// --------------------------------------------------------------------------

	// JavaDoc inherited from ChunkLoader
	public void loadChunk(Map map) throws ChunkLoadException {
		ArrayList alStrings = new ArrayList();

		int index = 0;
		int n = super.getBytesRemaining();

		while (index < n) {
			int j = index;
			for (; j < n; j++) {
				if (super.getByte(j) == 0)
					break;
			}

			if (j == n)
				break;

			String s = super.readString(j - index);
			super.readByte(); // Null character.
			alStrings.add(s);
			index += s.length() + 1;
		}

		String[] sa = new String[alStrings.size()];
		alStrings.toArray(sa);
		map.setMapObjectImages(sa);
	}
}
