package com.alienfactory.javamappy.util;



// -----------------------------------------------------------------------------
/**
 * ParameterCheck :: Gives the user helpful, friendly exception messages that
 * imply their code sucks. <br>
 *
 * @author Steve Eynon
 */
// -----------------------------------------------------------------------------
public class ParameterChecker {

	private ParameterChecker() {
	    // private constructor prevents instantiation
	}



	public static final void checkNotNull(Object parameter, String name) throws IllegalArgumentException {
		if (null == parameter)
			throw new IllegalArgumentException("Input parameter [" + name + "] cannot be null");
	}



	public static final void checkMin(int parameter, String name, int min) throws IllegalArgumentException {
		if (parameter < min)
			 throw new IllegalArgumentException("Input parameter [" + name + " :: " + parameter + "] was out of bounds - " + name + " should be greater than or equal to " + min);
	}



	public static final void checkMax(int parameter, String name, int max) throws IllegalArgumentException {
		if (parameter > max)
			 throw new IllegalArgumentException("Input parameter [" + name + " :: " + parameter + "] was out of bounds - " + name + " should be less than or equal to " + max);
	}



	public static final void checkMinMax(int parameter, String name, int min, int max) throws IllegalArgumentException {
		checkMin(parameter, name, min);
		checkMax(parameter, name, max);
	}

}
