package com.alienfactory.javamappy.viewer.render;

import javax.microedition.lcdui.Graphics;

import com.alienfactory.javamappy.Map;
import com.alienfactory.javamappy.util.ParameterChecker;



//------------------------------------------------------------------------------
/**
 * J2MERenderer <br>
 *
 * @author Steve Eynon
 **/
// ------------------------------------------------------------------------------
abstract class J2MERenderer implements Renderer {
	private 	int 		clipX, 	clipY;
	private 	int 		clipWidth,	clipHeight;
	protected	final int	blockWidth;
	protected	final int	blockHeight;
	protected 	final int	halfBlockWidth;



	// -------------------------------------------------------------------------
	// Constructors
	// -------------------------------------------------------------------------

	J2MERenderer(Map map) {
		ParameterChecker.checkNotNull(map, "map");
		blockWidth  	= map.getMapHeader().getBlockWidth();
		blockHeight 	= map.getMapHeader().getBlockHeight();
		halfBlockWidth	= blockWidth / 2;
	}



	// -------------------------------------------------------------------------
	// Renderer Interface Methods
	// -------------------------------------------------------------------------

	public void setClip(Object objGFX, int x, int y, int width, int height) throws IllegalArgumentException {
		Graphics gfx 	= (Graphics) objGFX;

		// save out the existing clip
		clipX 		= gfx.getClipX();
		clipY 		= gfx.getClipX();
		clipWidth 	= gfx.getClipWidth();
		clipHeight	= gfx.getClipHeight();

		gfx.setClip(x, y, width, height);

	}



	public void restoreClip(Object objGFX) throws IllegalArgumentException {
		Graphics gfx 	= (Graphics) objGFX;
		gfx.setClip(clipX, clipY, clipWidth, clipHeight);
	}
}
