import java.awt.Graphics;
import java.io.FileInputStream;

import javax.swing.JFrame;

import com.alienfactory.javamappy.Map;
import com.alienfactory.javamappy.loader.MapLoader;
import com.alienfactory.javamappy.util.Logger;
import com.alienfactory.javamappy.viewer.MapViewer;
import com.alienfactory.javamappy.viewer.render.JDK12Renderer;
import com.alienfactory.javamappy.viewer.render.Renderer;



//------------------------------------------------------------------------------
/**
 * <p>A Simple JavaMappy Example. </p>
 *
 * <p>This example loads the test map, opens a window and displays it. </p>
 *
 * @author Steve Eynon of <a href="http://www.alienfactory.co.uk/">Alien-Factory</a>.
 **/
//------------------------------------------------------------------------------
public class SimpleExample extends JFrame {
	private	static MapViewer mapViewer;

	public void paint(Graphics gfx) {
		mapViewer.draw(gfx, false);
	}

	public static void main(String[] args) throws Exception {
		Logger.setLoggingEnabled(true);

		// use the JavaMappy API to load the test map
		FileInputStream mapStream = new FileInputStream("maps/alienEpidemic.fmp");
		Map map 	= MapLoader.loadMap(mapStream);
		Renderer r	= new JDK12Renderer(map);
		mapViewer 	= new MapViewer(map, r, 320, 256);
		mapStream.close();

		// use the Swing API to display the map
		SimpleExample window = new SimpleExample();
		window.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		window.setSize(320, 256);
		window.setVisible(true);
	}
}
